/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-03-20 15:12:36 UTC)
 * on 2013-03-22 at 20:37:10 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.orkut.model;

/**
 * Model definition for CommunityMembers.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Orkut API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class CommunityMembers extends com.google.api.client.json.GenericJson {

  /**
   * Status and permissions of the user related to the community.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private CommunityMembershipStatus communityMembershipStatus;

  /**
   * Kind of this item. Always orkut#communityMembers.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * Description of the community member.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private OrkutActivitypersonResource person;

  /**
   * Status and permissions of the user related to the community.
   * @return value or {@code null} for none
   */
  public CommunityMembershipStatus getCommunityMembershipStatus() {
    return communityMembershipStatus;
  }

  /**
   * Status and permissions of the user related to the community.
   * @param communityMembershipStatus communityMembershipStatus or {@code null} for none
   */
  public CommunityMembers setCommunityMembershipStatus(CommunityMembershipStatus communityMembershipStatus) {
    this.communityMembershipStatus = communityMembershipStatus;
    return this;
  }

  /**
   * Kind of this item. Always orkut#communityMembers.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Kind of this item. Always orkut#communityMembers.
   * @param kind kind or {@code null} for none
   */
  public CommunityMembers setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Description of the community member.
   * @return value or {@code null} for none
   */
  public OrkutActivitypersonResource getPerson() {
    return person;
  }

  /**
   * Description of the community member.
   * @param person person or {@code null} for none
   */
  public CommunityMembers setPerson(OrkutActivitypersonResource person) {
    this.person = person;
    return this;
  }

  @Override
  public CommunityMembers set(String fieldName, Object value) {
    return (CommunityMembers) super.set(fieldName, value);
  }

  @Override
  public CommunityMembers clone() {
    return (CommunityMembers) super.clone();
  }

}
