/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-03-20 15:12:36 UTC)
 * on 2013-03-22 at 20:37:10 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.orkut.model;

/**
 * Model definition for CommunityTopic.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Orkut API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class CommunityTopic extends com.google.api.client.json.GenericJson {

  /**
   * The creator of the topic.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private OrkutAuthorResource author;

  /**
   * The body of the topic.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String body;

  /**
   * The ID of the topic.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.lang.Long id;

  /**
   * Whether the topic is closed for new messages.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean isClosed;

  /**
   * Identifies this resource as a community topic. Value: "orkut#communityTopic"
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * The timestamp of the last update, in RFC 3339 format.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private com.google.api.client.util.DateTime lastUpdate;

  /**
   * Snippet of the last message posted on this topic.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String latestMessageSnippet;

  /**
   * List of resources for the community.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<OrkutLinkResource> links;

  static {
    // hack to force ProGuard to consider OrkutLinkResource used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(OrkutLinkResource.class);
  }

  /**
   * Most recent messages.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<CommunityMessage> messages;

  /**
   * The total number of replies this topic has received.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer numberOfReplies;

  /**
   * The title of the topic.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String title;

  /**
   * The creator of the topic.
   * @return value or {@code null} for none
   */
  public OrkutAuthorResource getAuthor() {
    return author;
  }

  /**
   * The creator of the topic.
   * @param author author or {@code null} for none
   */
  public CommunityTopic setAuthor(OrkutAuthorResource author) {
    this.author = author;
    return this;
  }

  /**
   * The body of the topic.
   * @return value or {@code null} for none
   */
  public java.lang.String getBody() {
    return body;
  }

  /**
   * The body of the topic.
   * @param body body or {@code null} for none
   */
  public CommunityTopic setBody(java.lang.String body) {
    this.body = body;
    return this;
  }

  /**
   * The ID of the topic.
   * @return value or {@code null} for none
   */
  public java.lang.Long getId() {
    return id;
  }

  /**
   * The ID of the topic.
   * @param id id or {@code null} for none
   */
  public CommunityTopic setId(java.lang.Long id) {
    this.id = id;
    return this;
  }

  /**
   * Whether the topic is closed for new messages.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getIsClosed() {
    return isClosed;
  }

  /**
   * Whether the topic is closed for new messages.
   * @param isClosed isClosed or {@code null} for none
   */
  public CommunityTopic setIsClosed(java.lang.Boolean isClosed) {
    this.isClosed = isClosed;
    return this;
  }

  /**
   * Identifies this resource as a community topic. Value: "orkut#communityTopic"
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Identifies this resource as a community topic. Value: "orkut#communityTopic"
   * @param kind kind or {@code null} for none
   */
  public CommunityTopic setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The timestamp of the last update, in RFC 3339 format.
   * @return value or {@code null} for none
   */
  public com.google.api.client.util.DateTime getLastUpdate() {
    return lastUpdate;
  }

  /**
   * The timestamp of the last update, in RFC 3339 format.
   * @param lastUpdate lastUpdate or {@code null} for none
   */
  public CommunityTopic setLastUpdate(com.google.api.client.util.DateTime lastUpdate) {
    this.lastUpdate = lastUpdate;
    return this;
  }

  /**
   * Snippet of the last message posted on this topic.
   * @return value or {@code null} for none
   */
  public java.lang.String getLatestMessageSnippet() {
    return latestMessageSnippet;
  }

  /**
   * Snippet of the last message posted on this topic.
   * @param latestMessageSnippet latestMessageSnippet or {@code null} for none
   */
  public CommunityTopic setLatestMessageSnippet(java.lang.String latestMessageSnippet) {
    this.latestMessageSnippet = latestMessageSnippet;
    return this;
  }

  /**
   * List of resources for the community.
   * @return value or {@code null} for none
   */
  public java.util.List<OrkutLinkResource> getLinks() {
    return links;
  }

  /**
   * List of resources for the community.
   * @param links links or {@code null} for none
   */
  public CommunityTopic setLinks(java.util.List<OrkutLinkResource> links) {
    this.links = links;
    return this;
  }

  /**
   * Most recent messages.
   * @return value or {@code null} for none
   */
  public java.util.List<CommunityMessage> getMessages() {
    return messages;
  }

  /**
   * Most recent messages.
   * @param messages messages or {@code null} for none
   */
  public CommunityTopic setMessages(java.util.List<CommunityMessage> messages) {
    this.messages = messages;
    return this;
  }

  /**
   * The total number of replies this topic has received.
   * @return value or {@code null} for none
   */
  public java.lang.Integer getNumberOfReplies() {
    return numberOfReplies;
  }

  /**
   * The total number of replies this topic has received.
   * @param numberOfReplies numberOfReplies or {@code null} for none
   */
  public CommunityTopic setNumberOfReplies(java.lang.Integer numberOfReplies) {
    this.numberOfReplies = numberOfReplies;
    return this;
  }

  /**
   * The title of the topic.
   * @return value or {@code null} for none
   */
  public java.lang.String getTitle() {
    return title;
  }

  /**
   * The title of the topic.
   * @param title title or {@code null} for none
   */
  public CommunityTopic setTitle(java.lang.String title) {
    this.title = title;
    return this;
  }

  @Override
  public CommunityTopic set(String fieldName, Object value) {
    return (CommunityTopic) super.set(fieldName, value);
  }

  @Override
  public CommunityTopic clone() {
    return (CommunityTopic) super.clone();
  }

}
